import java.util.Vector;
import java.util.Hashtable;


/** Relational project operator; specify symbols to project
 *
 * @author Zack Ives
 * @version 1.0
 */

class Project extends Operator {
    Operator _child;
    Vector _project;
    Table _table;
    
    // Constructor - project symbols from child
    public Project(Operator child, Vector symbols, Hashtable symbolTable) {
        super (symbols, symbolTable);
        _child = child;
        
        if (_child != null) {
            _table = new Table("p");
            for (int i = 0; i < _symbols.size(); i++) {
                _table.addAttribute((String)_symbolTable.get(variables().elementAt(i)));
            }
        }
    }
    
    // Replace the child operator
    public boolean setChild(Operator child) {
        _child = child;
        
        _table = new Table("p");
        for (int i = 0; i < _symbols.size(); i++) {
            if (!_symbolTable.containsKey(variables().elementAt(i)) || 
                _symbolTable.get(variables().elementAt(i)).equals("")) {
                System.err.println("Undefined variable " + variables().elementAt(i));
                return false;
            }
            _table.addAttribute((String)_symbolTable.get(variables().elementAt(i)));
        }
        return true;
    }
    
    // Return attribute mappings
    public Table attribs() {
        return _table;
    }
    
    // Return string representation
    public String toString() {
        String temp = "Project[";
        for (int i = 0; i < _table.size(); i++) {
            if (i > 0)
                temp += ", ";
            temp += _table.getAttribute(i);
        }

        return temp + "](" + _child.toString() + ")";
    }
}