import java.util.Vector;
import java.util.Hashtable;

/** Simple wrapper scan operator
 *
 * @author Zack Ives
 * @version 1.0
 */

class Scan extends Operator {
    String _edbName;
    Vector _attribs;
    Table _table;
    
    // Constructor - Scan an EDB name, given a set of datalog variables and a table definition
    public Scan(String edbName, Vector symbols, Table table, Hashtable symbolTable) {
        super (symbols, symbolTable);
        _edbName = edbName;
        _table = table;
        
        // Map symbol table entries to our symbols
        for (int i = 0; i < _symbols.size(); i++) {
            _symbolTable.put(_symbols.elementAt(i), attribs().name() + "." + _table.getAttribute(i));
        }
    }

    // String representation
    public String toString() {
        String temp ="Scan[";
        for (int i = 0; i < _symbols.size(); i++) {
            if (i > 0)
                temp += ",";

            temp += _table.getAttribute(i);
        }
        temp += "](" + _edbName + ")";
        return temp;
    }

    // Return the table's attributes
    public Table attribs() {
        return _table;
    }
}