import java.util.Vector;

// Simple representation of a table and its attributes
class Table {
    Vector _attribs;
    String _name;
    
    // Create a table
    public Table(String name) {
        _name = name;
        _attribs = new Vector();
    }
    
    // Constructor with default vector of elements
    public Table(String name, Vector v) {
        _name = name;
        _attribs = v;
    }
    
    // Insert a new attribute
    public void addAttribute(String attrName) {
        _attribs.addElement(attrName);
    }
    
    // Look up an attribute by index
    public String getAttribute(int index) {
        return (String)_attribs.elementAt(index);
    }
    
    // Gets the index of an attribute given its name
    public int getIndex(String attrName) {
        return _attribs.indexOf(attrName);
    }
    
    // Table name
    public String name() {
        return _name;
    }
    
    // Number of attributes
    public int size() {
        return _attribs.size();
    }
}